mod client;
mod field;
mod queue;

use client::{Client, Reply, Request};
use field::Field;
use std::sync::mpsc::{channel, Sender};

#[derive(Clone)]
pub struct MoreThanText {
    tx: Sender<Request>,
}

impl MoreThanText {
    pub fn new() -> Self {
        let tx = Client::start();
        Self { tx: tx }
    }

    pub fn request<F>(&self, _session: Option<F>) -> Reply
    where
        F: Into<Field>,
    {
        let (tx, rx) = channel();
        let req = Request::new(tx);
        self.tx.send(req).unwrap();
        rx.recv().unwrap()
    }
}
